Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?

From: <[email-masked]>
Date: Sun, 1 Nov 2009 11:52:28 -0000

Thanks Sasha...in-line please: 

> -----Original Message-----
> From: Alexander Vainshtein [mailto:[email-masked]] 
> Sent: 31 October 2009 12:05
> To: Harrison,N,Neil,DEY2 R
> Cc: [email-masked]; [email-masked]
> Subject: RE: [mpls-tp] If a PW is a sublayer, why is it different?
> 
> Neil,
> IMHO and FWIW - yes, it is too late to try to make MPLS-TP 
> data plane different from that of MPLS. Please see 
> Requirement #1 in RFC 5654. This includes, among other 
> things, TTL processing.

NH=> Yes, I do concede that is almost certainly too late to stop some
mistakes happening now.  But they are arch mistakes nonetheless.  
> 
> I must admit that I do not see why using GAL and ACH header 
> in the OAM flows is problematic. Please remember, that, in 
> full accordance with the MPLS data plane rules, GAL shall be 
> looked at only by the node that has popped/terminated all the 
> labels above it in the label stack. Hence OAM shall be indeed 
> initiated and terminated at the trail termination points of 
> MPLS-TP "trails".

NH=> I agree it can be made to work.  But wrt good protocol design, DP
OAM should look as identical to DP taffic as we can make it, and this
will not be the case here.  Way back when Y.1711 was being done I was
not happy at all to have the OAM under an additional label 14
header....the OAM indicate function (1 bit of information is all that if
required) should be part of the normal forwarding header, and all
clients should be treated equally.  

A more subtle point which relates to this OAM issue and 'all clients
being treated equally' is the S-bit ....by definition the S-bit means we
do treat treat all clients equally.....which BTW still needs the
difference between 'internal' LSP clients (ie sublayering in same MPLS
layer network) from 'external' LSP clients (ie true client/server
layering between different party owned MPLS networks).  More generally
however, I really do not think arbitrary sublayering is a good idea for
a transport network.  And in MPLS as-is now it's really only the outer
label that deals with forwarding....inner labels carry other semantics
in general...which is fine until we get misconnectivity problems.
> 
> Last but not least, I believe that, within the MPLS data 
> plane, there are just two ways to implement the traceroute function:
> - by sending a sequence of packets with increasing TTL of the 
> top label starting with 2
> - by placing the "router alert" label on top of the label 
> stack of every "tracing" packet.

NH=> What about FR, ATM, SDH VCs, OTN, etc....all these co-ps/cs
networks do not do a child packet level tracing function, and none of
them use a TTL anyway.  If we have some major tracing problems here I am
not aware of them...have you seen this problem in co mode networks
Sasha?  My personal view is that in co mode networks we should, however,
be able to periodically (or as an on-demand function) check whether the
fowarding DP tables in nodes tally with what the CP/MP believes are
established connections (this would also pick-up potentially latent
problems in forwarding tables).  It helps here if one's labels do not
get swapped but are absolute like in the cl-ps mode case...PBB-TE for
example is like this.  One also gets the benefit that the network also
becomes self-protecting wrt leaking customer traffic even without any
OAM if we do not swap labels ...just like the cl-ps mode is. 

regards Neil

> 
> My 2c,
>      Sasha
> 
> 
> ________________________________________
> From: [email-masked] [[email-masked]]
> Sent: Thursday, October 29, 2009 11:35 PM
> To: Alexander Vainshtein; [email-masked]
> Cc: [email-masked]
> Subject: RE: [mpls-tp] If a PW is a sublayer, why is it different?
> 
> Sasha,
> 
> I'll say it again because I would really like to avoid as 
> many arch errors as possible whilst we are still 
> specifying/standardising MPLS-TP (I'll assumes it's not done 
> deal yet ;-)).... the DP OAM of MPLS-TP should NOT appear 
> under the GAL.  The GAL ought to be reserved for CP/MP 
> protocols only and it should never appear in the traffic 
> DP....but it will if it is used for OAM because OAM should be 
> generated/terminated at the trail termination points of 
> MPLS-TPs and these are most definitely in the traffic DP.  
> Further, by applying the GAL to DP OAM and not DP traffic 
> units we do not have close alignment between OAM and traffic 
> header structures....and that is pretty bad protocol design IMO.
> 
> Is it really too late now to get this done right?  And are we 
> really going to waste 8 bits (ie 25%) of very scarce MPLS 
> traffic unit header on a redundant TTL function?....the CP/MP 
> MUST verify a connection has no loops before it can be 
> established, just like all other co-cs/ps technologies do, 
> including those using a GMPLS CP!
> 
> If we are then we should state the real commercial and/or 
> political reasons that are forcing this mistake to be made in 
> MPLS-TP ...because it sure as anything does not stack-up technically.
> 
> regards, Neil
> > -----Original Message-----
> > From: [email-masked]
> > [mailto:[email-masked]] On Behalf Of Alexander Vainshtein
> > Sent: 29 October 2009 19:57
> > To: Shahram Davari
> > Cc: [email-masked]'
> > Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?
> >
> > Shaharam,
> > You are right, of course, thank you for the clarification.
> > This can be used as an explanation (of sorts) why PW sub-layer is 
> > different.
> >
> > Now let me ask you the following question.
> >
> > Suppose (just suppose) I am running a L3 VPN on top of MPLS-TP and 
> > want to run some kind of data plane OAM between a pair of VRFs in a 
> > given L3 VPN instance.
> >
> > Should I do that using GAL or using VCCV? Or do I have to 
> invent a new 
> > mechanism for this purpose because these packets are 
> neither PWs nor 
> > MPLS-TP LSPs?
> >
> > (The answer would be simple in the case of VPLS, because VSIs are 
> > interconnected over PWs. But L3 VPNs historically preceded PWs, so 
> > they do not use them.)
> >
> > My 2c,
> >      Sasha
> >
> > > -----Original Message-----
> > > From: Shahram Davari [mailto:[email-masked]]
> > > Sent: Thursday, October 29, 2009 6:44 PM
> > > To: Alexander Vainshtein; [email-masked]';
> > [email-masked]'
> > > Cc: [email-masked]'
> > > Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?
> > >
> > > Hi sasha
> > >
> > > The GAL rfc says it must not be used for PW
> > >
> > > Shahram
> > >
> > > ----- Original Message -----
> > > From: [email-masked] <[email-masked]>
> > > To: Adrian Farrel <[email-masked]>; Luca Martini 
> > > <[email-masked]>
> > > Cc: [email-masked] <[email-masked]>
> > > Sent: Wed Oct 28 22:34:25 2009
> > > Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?
> > >
> > > Adrian, Luca and all,
> > > I agree with Adrian: data plane-wise S-PE is not different from P.
> > >
> > > The differences come with the control plane (which may be 
> absent in
> > > MPLS-TP) or with OAM which, AFAIK, has not yet been
> > standardized for
> > > MS-PWs and which, in an case, may be also absent the operator's 
> > > choice.
> > >
> > > On the other hand, when it comes to OAM, the answer to 
> the original 
> > > question IMHO has a very practical implication:
> > >
> > > If I want to run OAM in an MS-PW that runs in an MPLS-TP
> > network, do I
> > > have to use GAL as the last label in the label stack and
> > followed by
> > > the ACH header (as defined in RFC 5586), or can I run it 
> using VCCV 
> > > (as defined in RFC 5085)?
> > >
> > > My 2c,
> > >      Sasha
> > >
> > >
> > > > -----Original Message-----
> > > > From: [email-masked]
> > > > [mailto:[email-masked]] On Behalf Of Adrian Farrel
> > > > Sent: Thursday, October 29, 2009 1:53 AM
> > > > To: Luca Martini
> > > > Cc: [email-masked]
> > > > Subject: Re: [mpls-tp] If a PW is a sublayer, why is it 
> different?
> > > >
> > > > Luca,
> > > >
> > > > Perhaps I didn't explain my question clearly enough.
> > > >
> > > > In the data plane of an MPLS-TP network (so it is all 
> one server 
> > > > type - MPLS-TP), is there any difference in behavior in
> > an S-PE and
> > > > P node when switching packets?
> > > >
> > > > Let me draw a network...
> > > >
> > > >
> > > > A==B==C***D***E
> > > >
> > > > Consider that I build two LSP tunnels ABC and CDE.
> > > > Now suppose I want an LSP (note: not a PW) form A to E.
> > It runs ACE
> > > > using the two tunnels.
> > > > At C, when a packet is received, the top label is popped
> > (end of LSP
> > > > ABC) and the exposed label is used for forwarding. Then a
> > new label
> > > > is imposed (LSP CDE) before the packet is sent onward.
> > > >
> > > > Now, let me draw another network.
> > > >
> > > > A==B==C***D***E
> > > >
> > > > Consider that I build two LSP tunnels ABC and CDE.
> > > > Now suppose I want a PW (note: not an LSP) form A to E.
> > It runs ACE
> > > > using the two tunnels.
> > > > At C, when a packet is received, the top label is popped
> > (end of LSP
> > > > ABC) and the exposed label is used for forwarding. Then a
> > new label
> > > > is imposed (LSP CDE) before the packet is sent onward.
> > > >
> > > > In the first case, node C is a P-node.
> > > > In the second case, node C is an S-PE.
> > > > There is nothing that precludes or requires node C to be on any 
> > > > domain boundary.
> > > >
> > > > What is the difference in the data plane between node C
> > in the first
> > > > case and node C in the second case?
> > > >
> > > > It is important (to me) to limit this question to the
> > data plane. I
> > > > don't care how the LSPs or PWs are set up or what service
> > they are
> > > > delivering.
> > > >
> > > > Thanks,
> > > > Adrian
> > > >
> > > > ----- Original Message -----
> > > > From: "Luca Martini" <[email-masked]>
> > > > To: "Adrian Farrel" <[email-masked]>
> > > > Cc: <[email-masked]>
> > > > Sent: Wednesday, October 28, 2009 10:31 PM
> > > > Subject: Re: [mpls-tp] If a PW is a sublayer, why is it 
> different?
> > > >
> > > > > Hi Adrian,
> > > > >
> > > > > An S-PE is very different. A P node has no knowledge of
> > > > what is in the PW,
> > > > > what specific parameters are incompatible with the 2 PWs.
> > > > block or fake PW
> > > > > OAM, etc...
> > > > > An S-PE is an administrative , and control point for the
> > > > MS-PW. While a P
> > > > > Router switches all LSP the same , and does not even have
> > > > to be a MIP.
> > > > > Also an S-PE can connect PWs running on completely
> > > different server
> > > > > networks, without any interworking function at the
> > network layer.
> > > > >
> > > > > Luca
> > > > >
> > > > >
> > > > >
> > > > > Adrian Farrel wrote:
> > > > >> So trying to take this a step further...
> > > > >>
> > > > >> If a PW is "just a label" making it "just a sub-layer" why
> > > > do we insist
> > > > >> that it is in any way different within the network?
> > > > >>
> > > > >> How is an S-PE that switches PW segments any different
> > > > from a P-node that
> > > > >> switches LSP segments? True, the S-PE must terminate the
> > > > LSP tunnel (pop
> > > > >> a label) before finding the PW label on which to switch.
> > > > But this same
> > > > >> function could apply at a P-node that is switching an
> > > LSP that was
> > > > >> carried in a tunnel.
> > > > >>
> > > > >
> > > > >> If this is the case, shouldn't we *include* PWs in the
> > > > Survivability
> > > > >> Framework:
> > > > >> - as automatically the same as LSPs
> > > > >> - with some examples to show how the function if achieved.
> > > > >>
> > > > >> To repeat: How are PWs any different within the network.
> > > > >>
> > > > >
> > > > >> [In answering, please recall that we are talking about
> > > > MPLS-TP networks
> > > > >> only.]
> > > > >>
> > > > >> Thanks,
> > > > >> Adrian
> > > > >>
> > > > >> ----- Original Message ----- From: "David Allan I"
> > > > >> <[email-masked]>
> > > > >> To: "Sprecher, Nurit (NSN - IL/Hod HaSharon)"
> > > > <[email-masked]>;
> > > > >> <[email-masked]>
> > > > >> Sent: Wednesday, October 28, 2009 4:41 PM
> > > > >> Subject: Re: [mpls-tp] Is PW a layer of MPLS-TP
> > > > >>
> > > > >>
> > > > >>> Hi Nurit:
> > > > >>>
> > > > >>> I think you misunderstand me. My comment on whether we
> > > > supported clients
> > > > >>> besides PWs was to illustrate second order consequences,
> > > > not to suggest
> > > > >>> that OAM was wagging the dog or was involved in
> > > > delineation of layers
> > > > >>> and sublayers...
> > > > >>>
> > > > >>> IMO all labels between the link layer preamble and the
> > > > label with the S-
> > > > >>> bit set are either reserved functions or sub-layers of
> > > > the MPLS-TP
> > > > >>> "layer", "sub-layers" AND reserved labels being what
> > > was known as
> > > > >>> "levels" in RFC 3031. All sub layers have the potential
> > > > to be switched
> > > > >>> including the PW sub-layer, ergo a PW is a sub-layer of
> > > MPLS-TP...
> > > > >>>
> > > > >>> I hope I'm clear...
> > > > >>>
> > > > >>> Cheers
> > > > >>> D
> > > > >>>
> > > > >>> -----Original Message-----
> > > > >>> From: Sprecher, Nurit (NSN - IL/Hod HaSharon) 
> > > > >>> [mailto:[email-masked]]
> > > > >>> Sent: Wednesday, October 28, 2009 12:27 PM
> > > > >>> To: David Allan I; [email-masked]
> > > > >>> Subject: RE: [mpls-tp] Is PW a layer of MPLS-TP
> > > > >>>
> > > > >>> Hi Dave,
> > > > >>> I am afraid again that relying on OAM to distinnguish
> > > between the
> > > > >>> clients is a wrong approach.
> > > > >>> Best regadrs,
> > > > >>> Nurit
> > > > >>>
> > > > >>> -----Original Message-----
> > > > >>> From: [email-masked]
> > > > [mailto:[email-masked]] On
> > > > >>> Behalf Of ext David Allan I
> > > > >>> Sent: Wednesday, October 28, 2009 6:02 PM
> > > > >>> To: [email-masked]
> > > > >>> Subject: [mpls-tp] Is PW a layer of MPLS-TP
> > > > >>>
> > > > >>> HI Adrian:
> > > > >>>
> > > > >>> IMO the S-bit is set in the PW label and clear in the
> > > > encapsulating
> > > > >>> sub-layers, hence it is a sub-layer in the G.805 sense
> > > of MPLS-TP.
> > > > >>>
> > > > >>> IMO it does confuse the landscape as OAM discrimination
> > > > requires apriori
> > > > >>> knowledge of the label type at bottom of stack IF we
> > > > assume a BOS can be
> > > > >>> other than a PW...
> > > > >>>
> > > > >>> My 2 cents
> > > > >>> D
> > > > >>>
> > > > >>> You wrote>>>>
> > > > >>>
> > > > >>> Hi,
> > > > >>>
> > > > >>> I am trying this question again with a different 
> subject line.
> > > > >>>
> > > > >>>
> > > > >>> It would be helpful to have more answers than just Neil's
> > > > (not that I
> > > > >>> don't value his view, but one person doesn't make 
> consensus!)
> > > > >>>
> > > > >>> My question:
> > > > >>>
> > > > >>> Hasn't the work on the MPLS-TP Framework draft judged PW
> > > > to be a client
> > > > >>> of MPLS-TP?
> > > > >>> That is, PW is not a layer of MPLS-TP, but the client.
> > > > >>>
> > > > >>> Doesn't that mean that PW survivability is out of scope
> > > > for the MPLS-TP
> > > > >>> Survivability I-D?
> > > > >>>
> > > > >>> Thanks,
> > > > >>> Adrian
> > > > >>> _______________________________________________
> > > > >>> mpls-tp mailing list
> > > > >>> [email-masked]
> > > > >>> https://www.ietf.org/mailman/listinfo/mpls-tp
> > > > >>> _______________________________________________
> > > > >>> mpls-tp mailing list
> > > > >>> [email-masked]
> > > > >>> https://www.ietf.org/mailman/listinfo/mpls-tp
> > > > >>>
> > > > >>
> > > > >> _______________________________________________
> > > > >> mpls-tp mailing list
> > > > >> [email-masked]
> > > > >> https://www.ietf.org/mailman/listinfo/mpls-tp
> > > > >
> > > > >
> > > >
> > > > _______________________________________________
> > > > mpls-tp mailing list
> > > > [email-masked]
> > > > https://www.ietf.org/mailman/listinfo/mpls-tp
> > > >
> > > _______________________________________________
> > > mpls-tp mailing list
> > > [email-masked]
> > > https://www.ietf.org/mailman/listinfo/mpls-tp
> > >
> > >
> > _______________________________________________
> > mpls-tp mailing list
> > [email-masked]
> > https://www.ietf.org/mailman/listinfo/mpls-tp
> >
>

---

From: Alexander Vainshtein <[email-masked]>
Date: Sun, 1 Nov 2009 15:53:17 +0200

Neil,
Lots of thanks for a prompt and very informative response.

I would like to discuss one specific point in your response, namely the need for traceroute
in MPLS-TP.

I read your message in this regard as questioning (if not negating) its usefulness in
MPLS-TP specifically and in CO networks in general.

I do not have much experience with  operation of ATM and FR networks.
But I believe that in SONET and SDH, ability to add "drop legs" to a trail
has been widely used in order to localize the problem. IMHO and FWIW,
traceroute essentially performs similar functionality in packet networks,
and is much better aligned with the data plane than "drop legs".

My 2c,
     Sasha

> From: [email-masked] [mailto:[email-masked]]
> Sent: Sunday, November 01, 2009 1:52 PM
> To: Alexander Vainshtein
> > From: Alexander Vainshtein
> [mailto:[email-masked]]